function BIO=biorythm(month,year,birth);
// BIORYTHM
//		 Calculation of Biorythm
//
//       BIO=biorythm(month,year,birth)
//
//       month   : month of biorythm analysis
//       year    : year for biorythm analysis
//       birth   : Date of birth. Array with three elements
//                 [DD MM YYYY]

QS=[1,month,year];

if month<12 then,
    QE=[1,month+1,year];
else
    QE=[1,1,year+1];
end

tagepromonat=dday([QS;QE]);
QE=calcdat(QE,-1);

ageindays=dday([birth;QS]);
taxdays=(0:1:tagepromonat-1)+ageindays;

BIO=zeros(3,length(taxdays));
BIO(1,:)=100 .*sin(2 .*%pi .*taxdays ./23);
BIO(2,:)=100 .*sin(2 .*%pi .*taxdays ./28);
BIO(3,:)=100 .*sin(2 .*%pi .*taxdays ./33);

dindex=1:1:tagepromonat;
XX=[dindex(:),dindex(:),dindex(:)];
clf();
plot2d(dindex,BIO.',leg='Body@Soul@Brain',style=[2,3,4]);
xtitle('Biorythm: '+part(int2str(birth(1)),11:12)+'.'+part(int2str(birth(2)),11:12)+'.'+part(int2str(birth(3)),9:12),'Days of@'+part(int2str(month),11:12)+'/'+part(int2str(year),9:12),'%');
f=get("current_figure");
f.figure_name='Biorythm';
axha=gca();
axha.grid=[1,1];

endfunction