function OUTMAT=csanaly(cs);
//CSANALY	Analysis of contour data
//
//	OUTMAT=CSANALY(cs);
//
//	characteristic data is collected and delivered to the Matrix OUTMAT
//	The number of rows of OUTMAT is equal to the number of contour lines.
//
//	column value
//	(1)	:	Height value
//	(2)	:	number of points
//	(3)	:	1. column index CS-Matrix
//	(4)	:	last column index
//	(5)	:	minimum X-value
//	(6)	:	maximum X-value
//	(7)	:	minimum Y-value
//	(8)	:	maximum Y-value
//	(9)	:	Start point (complex)
//	(10):	End point (complex) 

[z,s]=size(cs);
spos=1;
OUTMAT=[];
while (spos<s),
	vakt=cs(1,spos);
	nakt=cs(2,spos);
	xakt=cs(1,(spos+1):(spos+nakt));		// Auswahl entsprechender
	yakt=cs(2,(spos+1):(spos+nakt));		// Abschnitte der Matrix cs

	maxx=max(xakt);					// Ermitteln minimaler bzw.
	maxy=max(yakt);					// maximaler X-Y-Werte
	minx=min(xakt);
	miny=min(yakt);
	p1=xakt(1) + %i .*yakt(1); p2=xakt(nakt) + %i .*yakt(nakt);
	out=[vakt,nakt,spos+1,spos+nakt,minx,maxx,miny,maxy,p1,p2];
	OUTMAT=[OUTMAT;out];
	spos=spos+nakt+1;				// Zeiger auf nchsten Abschnitt
end;

endfunction