function [plist2,ksel]=delmulp(plist1,DSCHWELLE)
// DELMULP	delete multiple points in a vector
//
//		[PLIST2,KREST]=DELMULP(PLIST,DSCHWELLE)
//
//		PLIST is a complex vector, which contains points in R. Identical
//		points in the vector are removed. Points are interpreted as "multiple",
//		when their distance is smaller then DSCHWELLE to another point
//
//		The vector KREST contains the Indices of points from the input vector,
//		which are also available in the output vector.

[%nargout, %nargin]=argn(0);

if %nargin==1 then, DSCHWELLE=0; end

[zp,sp]=size(plist1);
plist1=plist1(:);
plist2=[];
krest=1:1:length(plist1);
ksel=[];

while length(plist1)>=1,		// Scannen der Liste
	pakt=plist1(1);
	ksel=[ksel,krest(1)];
	
	prest=plist1(2:length(plist1));
	krest=krest(2:length(plist1));

	d=abs(prest-pakt);
	plist2=[plist2;pakt];

	plist1=prest(d>DSCHWELLE);
	krest=krest(d>DSCHWELLE);
end

endfunction