function [p1,p2,entf]=distance(a,b,c,d)
//	DISTANCE	Minimum distance between to lines
//
//		[p1,p2,entf]=distance(a,b,c,d)
//
//		minimum distance between two lines                  
//		g1: x=a + r*b   ;   g2: x=c + s*d            
//
//		a,c		:	Local vectors
//		b,d		:	direction vectors  
//		p1,p2	:	points on lines with minimum distance  
//		entf	:	minimum distance                     

a=a(:).';
b=b(:).';		// Make row vectors
c=c(:).';
d=d(:).';

mtx=[b*b' -b*d';b*d' -d*d'];
vek=[c*b'-a*b';c*d'-a*d'];
rs=inv(mtx)*vek;
p1=a+b*rs(1,1);
p2=c+d*rs(2,1);
difvek=p2-p1;
entf=sqrt(difvek*difvek');

endfunction