function [C] = divide(A,B) 

// Ouput variables initialisation (not found in input variables)
C=[];

// Display mode
mode(0);

// Display warning for floating point exception
ieee(1);

// DIVIDEDivision (ohne Warnungsmeldung)
// 
//C=DIVIDE(A,B)
// 
//A,B: Skalar, Vektor oder Matrix mit identischer Gre
//C: Ergebnis der Division A/B
// 
//Bei der Version 4.0 MatLab knnen Warnungsmeldungen, die z. B.
//bei der Division durch Null entstehen, nicht unterdrckt werden.
//...   daher diese Prozedur ...

[za,sa] = size(mtlb_double(A));
[zb,sb] = size(mtlb_double(B));

if ~bool2s(za==zb)&bool2s(sa==sb) then
  return;
end;

if bool2s(za==1)&bool2s(sa==1) then
  if mtlb_logic(mtlb_double(B),"==",0) then
    C = %nan;
  else
    C = mtlb_double(A) ./mtlb_double(B);
  end;
else
  // !! L.28: Unknown function isvec not converted, original calling sequence used

  if ~mtlb_double(isvec(A)) then
    [pz0,ps0] = mtlb_find(bool2s(mtlb_logic(mtlb_double(B),"==",0)));
    if isempty(pz0) then
      C = mtlb_double(A) ./mtlb_double(B);
    else
      [pzw,psw] = mtlb_find(bool2s(mtlb_logic(mtlb_double(B),"~=",0)));
      %v03_2 = size(mtlb_double(A));  C = zeros(%v03_2(1),%v03_2(2));
    
      %v13_2 = size(pz0);  // !! L.36: Unknown function pumaval not converted, original calling sequence used
      C = pumaval(C,pz0,ps0,%nan .*ones(%v13_2(1),%v13_2(2)));
    
      // !! L.38: Unknown function gemaval not converted, original calling sequence used
      Aget = gemaval(A,pzw,psw);
      // !! L.39: Unknown function gemaval not converted, original calling sequence used
      Bget = gemaval(B,pzw,psw);
      Cput = mtlb_double(Aget) ./mtlb_double(Bget);
      // !! L.41: Unknown function pumaval not converted, original calling sequence used
      C = pumaval(C,pzw,psw,Cput);
    end;
  else
    pz0 = mtlb_find(bool2s(mtlb_logic(mtlb_double(B),"==",0)));
    if isempty(pz0) then
      C = mtlb_double(A) ./mtlb_double(B);
    else
      pzw = mtlb_find(bool2s(mtlb_logic(mtlb_double(B),"~=",0)));
      %v23_2 = size(mtlb_double(A));  C = zeros(%v23_2(1),%v23_2(2));
      %v33_2 = size(pz0);  C = mtlb_i(C,pz0,%nan .*ones(%v33_2(1),%v33_2(2)));
      C = mtlb_i(C,pzw,mtlb_double(mtlb_e(A,pzw)) ./mtlb_double(mtlb_e(B,pzw)));
    end;
  end;
end;
endfunction
