function [E] = erfcomp(z) 
//ERFCOMP error function with complex input arguments
//
//        E=erfcomp(Z)
// 
//the complex matrix Z is used as input argument for that function.
//Result is the errorfunction for these complex arguments. This
//function is useful for defining other functions like "Fresnel"

// Ouput variables initialisation (not found in input variables)
E=[];

// Display mode
mode(0);

// Display warning for floating point exception
ieee(1);



[zx,sx] = size(mtlb_double(z));
// Dimension der Eingabematrix
x = real(mtlb_double(z));
y = imag(mtlb_double(z));
x = x(:);
y = y(:);

i = sqrt(-1);
// E=erf(x);
KOa = 0.3275911;
// Hier erfolgt die Berechnung der
KOA = 0.254829592;
// Error-Funktion durch eine rationale
KOB = -0.284496736;
// Approximation fr reelle Argumente.
KOC = 1.421413741;
KOD = -1.453152027;
KOE = 1.061405429;
w = 1 ./(1+KOa .*abs(x));
P = KOE .*w+KOD;
P = P .*w+KOC;
P = P .*w+KOB;
P = P .*w+KOA;
P = P .*w;
Q = exp(-x .*x);
E = (1-Q .*P) .*sign(x);

%v0 = size(E);
S = zeros(%v0(1),%v0(2));
abserr = 100;
n = 1;
while abserr>0.000000000001
  fn = 2 .*x-((2 .*x) .*cosh(n .*y)) .*cos((2 .*x) .*y)+(n .*sinh(n .*y)) .*sin((2 .*x) .*y);
  gn = ((2 .*x) .*cosh(n .*y)) .*sin((2 .*x) .*y)+(n .*sinh(n .*y)) .*cos((2 .*x) .*y);
  fgn = ((fn+i .*gn) .*exp(-0.25 .*(n .^2))) ./(n .^2+4 .*(x .^2));
  Sakt = ((2 .*fgn) .*exp(-x .^2)) ./%pi;
  v01_1 = abs(Sakt);
  abserr = max(v01_1,firstnonsingleton(v01_1));
  n = n+1;
  S = mtlb_a(S,Sakt);
end;

ki = find(bool2s(bool2s(x==0)&bool2s(y==0)))';
if ~isempty(ki) then
  %v01_1 = size(ki);
  E = mtlb_i(E,ki,zeros(%v01_1(1),%v01_1(2)));
end;
ki = find(bool2s(bool2s(x==0)&bool2s(y~=0)))';
if ~isempty(ki) then
  E = mtlb_i(E,ki,(i .*y(ki)) ./%pi);
end;
ki = find(bool2s(bool2s(x~=0)&bool2s(y~=0)))';
if ~isempty(ki) then
  xk = x(ki);
  yk = y(ki);
  E = mtlb_i(E,ki,erf(xk)+(exp(-xk .^2) .*(1-cos((2 .*xk) .*yk)+i .*sin((2 .*xk) .*yk))) ./((2 .*%pi) .*xk));
end;
E = mtlb_a(E,S);
// !! L.63: WARNING: Matlab reshape() suppresses singleton higher dimension, it is not the case for matrix...
E = matrix(E,zx,sx);
endfunction
