function bound=findnext(v1,v2);
// FINDNEXT	Finding neighbours ...
//
//		BOUNDS=FINDNEXT(V1,V2)
//
//		The vector v2 contains numbers and the vector v1 is scanned
//		for the next smallest and the next larger value.
//		These both values are written to the matrix BOUNDS
//		(2 columns). The 1st column contains the next smallest, the
//		2nd column the next larger values.
//		If there is no next smallest value, the the lower boundary is the
//		minimal value of v1. Also if there is no next larger value, then
//		the maximum of v1 is used as result.

bound=[];
[%nargout, %nargin]=argn(0);
if %nargin~=2 then
	return;
end

v1=v1(:); v2=v2(:);
v1=gsort(v1); v1=v1($:-1:1);
v2=gsort(v2); v2=v2($:-1:1);

LV1=length(v1);
LV2=length(v2);
kx1=1:1:LV1; kx1=kx1(:);

bound=[];

for k=1:1:LV2,
	v2akt=v2(k);
	difv12=v1 - v2akt;
	
	bolow=v1(max(kx1(difv12<0)));
	bohigh=v1(min(kx1(difv12>0)));
	if isempty(bolow),
		bolow=v1(1);
	end
	if isempty(bohigh),
		bohigh=v1(LV1);
	end
	boakt=[bolow,bohigh];
	bound=[bound;boakt];
end

endfunction