function rv=gemaval(x,z,s);
//GEMAVAL	Get values from a matrix
//
//	RV=GEMAVAL(X,Z,S)
//
//	From a matrix the elements
//	X[Z(1),S(1)], X[Z(2),S(2)], ... , X[Z(N),S(N)]
//	are picked and given to the row vector RV.

rv=[];
z=z(:).';
s=s(:).';
[%nargout,%nargin]=argn(0);

// ------------------- Checking and preparing input arguments -------
if %nargin<3,
	disp('Missing Input Argument !');
	return;
end;

if size(z)~=size(s) then,
	disp('Index vectors must have same length !');
	return;
end;

z=round(z);
s=round(s);

[zx,sx]=size(x);
z(z>zx)=zx*ones(z(z>zx));
s(s>sx)=sx*ones(s(s>sx));
z(z<1)=ones(z(z<1));
s(s<1)=ones(s(s<1));

// --------------------- End of Checking ----------------------------

x=x(:).';				// Matrix -> Vector
elem=(s -1) .*zx + z;	// Matrix-Indices -> Vektor-Indices
rv=x(elem);		        // Auslesen

endfunction

function X=pumaval(x,z,s,v);
//PUMAVAL	Replace values in a matrix
//
//	X=PUMAVAL(X,Z,S,V)
//
//	The values of matrix X
//	X[Z(1),S(1)], X[Z(2),S(2)], ... , X[Z(N),S(N)]
//	are replaced by the values contained in vector V
//
//	X[Z(j),S(j)]=V(j)

[%nargout,%nargin]=argn(0);
X=x;

// ------------------- Checking arguments ---------------------
if %nargin<4,
	disp('Missing Input Argument !');
	return;
end;

if size(z)~=size(s) then,
	disp('Index vectors must have same length !');
	return;
end;

if size(z)~=size(v) then
	disp('Vector with replacement values has wrong length!');
	return;
end

z=round(z);
s=round(s);

[zx,sx]=size(x);
z(z>zx)=zx*ones(z(z>zx));
s(s>sx)=sx*ones(s(s>sx));
z(z<1)=ones(z(z<1));
s(s<1)=ones(s(s<1));
// --------------------- End of Checking ----------------------------

x=x(:).';				// Matrix -> Vector
elem=(s -1) .*zx + z;	// Matrix-Indices -> Vektor-Indices
x(elem)=v;		        // Ersetzen
X=matrix(x,zx,sx);		// Vektor-Matrix

endfunction