function [w1,w2] = gkn2geo(z,NR) 
//GKN2GEO  national GK coordinates -> geograph. coordinates
//[W1,W2]=GKN2GEO(Z,NR)
//W1: Vector with longitude values (DEG)
//W2: Vector with lattitude values (DEG)
//Z : complex vector with Gau-Krger coordinates.
//Real part=Right value, Imag. part =height value
//NR: number of meridional stripe
//
//IMPORTANT: Vectors must be column vectors !!!
// 
//Dr.-Ing. A. Geiler

// Ouput variables initialisation (not found in input variables)
w1=[];
w2=[];

// Number of arguments in function call
[%nargout,%nargin] = argn(0)

// Display mode
mode(0);

// Display warning for floating point exception
ieee(1);

if %nargin==1 then
  NR = floor(real(z)*0.000001);  // Meridianstreifennr.
end;
L0 = NR .*3;                     // Mittelmeridian

z=(real(z) - NR*1E6 - 5E5) + %i .*imag(z);
[w1,w2] = gkk2geo(z);
w1=w1 + L0;
endfunction
