function [Qout,WLE,WC,WS]=hitmiss(Qin,graf);
// HITMISS	Skelettierung von Binrbildern
//
//		[QOUT,WLE,WC,WS]=HITMISS(QIN)
//
//		QIN	:	Sparse-Matrix, die ein Binrbild reprsentiert.
//		Qout	:	Sparse-Matrix, die das Skelett des Binrbildes
//				beinhaltet.
//		WLE	:	Sparse-Matrix mit Linienendpunkten des Skeletts
//		WC	:	Sparse-Matrix mit Kreuzungspunkten des Skeletts
//		WS	:	Sparse-Matrix mit singulren Punkten.

Qinbackup=Qin;

LQ=0;
LQin=length(find(Qin));
LQbckup=LQin;

winID=progressionbar('No. of Points: '+int2str(LQin));

while LQin~=LQ,
	LQin=length(find(Qin));

	// North 1
	// --------
	WN1=bool2s(Qin & bool2s((~shiftmat(Qin,1,1))));
	WN1=bool2s(WN1 & bool2s((~shiftmat(Qin,0,1))));
	WN1=bool2s(WN1 & bool2s((~shiftmat(Qin,-1,1))));
	WN1=bool2s(WN1 & shiftmat(Qin,0,-1));
	WN1=bool2s(WN1 & shiftmat(Qin,-1,-1));

	// North 2
	// --------
	WN2=bool2s(Qin & bool2s((~shiftmat(Qin,0,1))));
	WN2=bool2s(WN2 & bool2s((~shiftmat(Qin,-1,1))));
	WN2=bool2s(WN2 & bool2s((~shiftmat(Qin,-1,0))));
	WN2=bool2s(WN2 & shiftmat(Qin,1,0));
	WN2=bool2s(WN2 & shiftmat(Qin,0,-1));

	Qin=bool2s(Qin & bool2s((~(WN1 | WN2))));

	// South 1
	// -------
	WS1=Qin & bool2s(~shiftmat(Qin,1,-1));
	WS1=WS1 & (~shiftmat(Qin,0,-1));
	WS1=bool2s(WS1 & (~shiftmat(Qin,-1,-1)));
	WS1=bool2s(WS1 & shiftmat(Qin,1,1));
	WS1=bool2s(WS1 & shiftmat(Qin,0,1));

	// South 2
	// -------
	WS2=Qin & bool2s((~shiftmat(Qin,1,0)));
	WS2=WS2 & (~shiftmat(Qin,1,-1));
	WS2=bool2s(WS2 & (~shiftmat(Qin,0,-1)));
	WS2=bool2s(WS2 & shiftmat(Qin,0,1));
	WS2=bool2s(WS2 & shiftmat(Qin,-1,0));

	Qin=bool2s(Qin & bool2s((~(WS1 | WS2))));

	// West 1
	// --------
	WW1=Qin & bool2s((~shiftmat(Qin,1,1)));
	WW1=WW1 & (~shiftmat(Qin,1,0));
	WW1=bool2s(WW1 & (~shiftmat(Qin,1,-1)));
	WW1=bool2s(WW1 & shiftmat(Qin,-1,1));
	WW1=bool2s(WW1 & shiftmat(Qin,-1,0));

	// West 2
	// --------
	WW2=Qin & bool2s((~shiftmat(Qin,1,1)));
	WW2=WW2 & (~shiftmat(Qin,1,0));
	WW2=bool2s(WW2 & (~shiftmat(Qin,0,1)));
	WW2=bool2s(WW2 & shiftmat(Qin,0,-1));
	WW2=bool2s(WW2 & shiftmat(Qin,-1,0));

	Qin=bool2s(Qin & bool2s((~(WW1 | WW2))));

	// East 1
	// -------
	WO1=Qin & bool2s(~shiftmat(Qin,-1,1));
	WO1=WO1 & (~shiftmat(Qin,-1,0));
	WO1=bool2s(WO1 & (~shiftmat(Qin,-1,-1)));
	WO1=bool2s(WO1 & shiftmat(Qin,1,0));
	WO1=bool2s(WO1 & shiftmat(Qin,1,-1));

	// East 2
	// -------
	WO2=Qin & bool2s(~shiftmat(Qin,-1,-1));
	WO2=WO2 & (~shiftmat(Qin,-1,0));
	WO2=bool2s(WO2 & (~shiftmat(Qin,0,-1)));
	WO2=bool2s(WO2 & shiftmat(Qin,1,0));
	WO2=bool2s(WO2 & shiftmat(Qin,0,1));

	Qin=bool2s(Qin & bool2s(~(WO1 | WO2)));

	Qout=Qin;
	LQ=length(find(Qout));
	progressionbar(winID,'No. of Points: '+int2str(LQin));
	Qin=Qout;
end
winclose(winID);


	WS=Qout;						// einzelner Punkt
	for k1=-1:1:1,
		for k2=-1:1:1,
			if ~(k1==0 & k2==0),
				WS=bool2s(WS & bool2s(~shiftmat(Qout,k1,k2)));
			end
		end
	end
								// Linienende
	msk1=[0,0,1;0,1,0;0,0,0];
	WLE1=maskand(Qout,msk1);
	WLE2=maskand(Qout,rot90(msk1,1));
	WLE3=maskand(Qout,rot90(msk1,2));
	WLE4=maskand(Qout,rot90(msk1,3));
	msk2=[0,1,0;0,1,0;0,0,0];
	WLE5=maskand(Qout,msk2);
	WLE6=maskand(Qout,rot90(msk2,1));
	WLE7=maskand(Qout,rot90(msk2,2));
	WLE8=maskand(Qout,rot90(msk2,3));
	WLE=bool2s(WLE1 | WLE2 | WLE3 | WLE4 | WLE5 | WLE6 | WLE7 | WLE8);

	msk2=[2,2,1;1,1,0;2,2,1];
	WC1=maskand(Qout,msk2);
	WC2=maskand(Qout,rot90(msk2,1));
	WC3=maskand(Qout,rot90(msk2,2));
	WC4=maskand(Qout,rot90(msk2,3));
	WCA=bool2s(WC1 | WC2 | WC3 | WC4);

	msk2=[2,1,2;1,1,2;2,1,2];
	WC1=maskand(Qout,msk2);
	WC2=maskand(Qout,rot90(msk2,1));
	WC3=maskand(Qout,rot90(msk2,2));
	WC4=maskand(Qout,rot90(msk2,3));
	WCB=bool2s(WC1 | WC2 | WC3 | WC4);

	msk2=[1,2,2;2,1,1;2,1,2];
	WC1=maskand(Qout,msk2);
	WC2=maskand(Qout,rot90(msk2,1));
	WC3=maskand(Qout,rot90(msk2,2));
	WC4=maskand(Qout,rot90(msk2,3));
	WCC=bool2s(WC1 | WC2 | WC3 | WC4);

	WC=bool2s(WCA | WCB | WCC);
	
	scf();
	f=get("current_figure");
	f.visible='off';
	f.figure_position=[90,20];
	f.figure_size=[900,900];
	f.figure_name='Hit & Miss';
	
	subplot(211);
	Matplot(Qinbackup+1,frameflag=4);
	f=get("current_figure");
	f.color_map=[1,1,1;0,0,1];
		
	subplot(212);
	Matplot(Qout+1,frameflag=4);
	f=get("current_figure");
	f.color_map=[1,1,1;0,0,1];
	f.visible='on';
	
endfunction
