function w=inerfc(z,n)
// INERFC	Repeated Integrals of the error function
//
//		W=INERFC(Z,N);
//
//		Taken from Abramowitz, Repeated Integral of the error
//		function.

if n>=1,
	w=(inerfc(z,n-2) ./(2*n)) - (z ./n) .*inerfc(z,n-1);
else
	if n==0,
		w=(1 - erfcomp(z));
	else
		if n==-1,
			w=(2 .*exp(-(z .^2)) ./sqrt(%pi));
		end
	end
end
endfunction;