function Q=intriang(ptri,points);
// INTRIANG	Are points within a triangle ?
//
//		Q=INTRIANG(PTRI,POINTS)
//
//		PTRI is a complex vector of length 3, which contains
//		the corners of a triangle. POINTS is a complex vector
//		or a matrix with points, which are checked, if they are
//		within the triangle.
//
//		Q is a binary Matrix with the same dimension like the
//		matrix or vector POINTS. A 1 is used for points, which
//		are within or on the corner of the triangle.
//
//		The decision is done by the checking the sum of areas,
//		which are build from the point and the triangle.

Q=[];
[%nargout,%nargin]=argn(0);
if %nargin<2 then
	return;
end

[zp,sp]=size(points);						// Size of POINTS (needed for later reshape)
points=points(:).';							// Make Row-Vector
ptri=meshgrid(ptri,1:1:length(points)).';	// extend triangle

A1=adreieck(ptri);							// area of the triangle

ptmp=ptri;									// partial areas
ptmp(1,:)=points;
A023=adreieck(ptmp);

ptmp=ptri;
ptmp(2,:)=points;
A013=adreieck(ptmp);

ptmp=ptri;
ptmp(3,:)=points;
A012=adreieck(ptmp);

Ages=A023 + A013 + A012;					// sum of partial areas regarding the points
Q=bool2s(abs(Ages-A1)<1E-6);				// within the triangle is equal to the area
Q=matrix(Q,zp,sp);							// of the triangle itself

endfunction