function Q=ipolygon(p,points)
// IPOLYGON	Points within a closed polygon ? ?
//
//		Q=IPOLYGON(P,POINTS)
//
//		From the complex points P the convex hull is calculated.
//		(P can even specify the convex hull itself). The complex
//		POINTS (Matrix or Vektor) are checked, whether they are
//		located on the border or within the polygon.
//
//		Result is a boolean matrix with the same dimension as POINTS.

p=p(:).';
pr=[real(p);imag(p)];
[npoi,Vidx]=convex_hull(pr);
V=p(Vidx);

[mp,r,PL]=delaunay(V);		    	// Delaunay-Triangulation
									// convex hull is build by triangles
PL=PL(1:3,:);			        	// point list of triangles is redundant
									// in 4. row
NPL=size(PL,2);			        	// number of triangles
Q=zeros(points);					// Boolean result matrix

for k=1:1:NPL,
   ptri=PL(:,k);		        	// aktuelles Dreieck
   Q=max(Q,intriang(ptri,points));	// Punkt im aktuellen Dreieck ?
end
endfunction