function [I] = isprime(a)
//ISPRIME  True for prime numbers.
// 
//ISPRIME(P)
// 
//returns 1s for the prime elements
//in matrix P and 0s for the others.

// Ouput variables initialisation (not found in input variables)
I=[];

// Display mode
mode(0);

// Display warning for floating point exception
ieee(1);

%v0 = size(mtlb_double(a));
I = zeros(%v0(1),%v0(2));
// First eliminate all the entries
// that are divisible by the lowest primes
if isempty(I) then
  return;
end;
a = mtlb_t(mtlb_e(a,:));
lps = 1 ./[2,3,5,7,11,13]';
A = lps*mtlb_double(a)+%pi*mtlb_logic(lps*mtlb_double(a),"==",1);
ipp = mtlb_find(bool2s(bool2s(mtlb_logic(mtlb_double(a),">",1))&bool2s(bool2s(~mtlb_double(a)-fix(mtlb_double(a) ./1) .*1)&bool2s(~sum(bool2s(~A-fix(A ./1) .*1),1)))));

// Only generate primes for and test those that passed the first test
%v0 = mtlb_double(mtlb_e(a,ipp));
lps = mtlb_imp(17,2,mtlb_double(mtlb_max(%v0,firstnonsingleton(%v0)))^(1/2));

// if lps is empty, then there are no other possible divisors to test
if ~isempty(lps) then
  // !! L.24: Matlab function isprime not yet converted, original calling sequence used
  foo = isprime(lps);
  // ! L.25: abs(mtlb_double(foo)) may be replaced by:
  // !    --> mtlb_double(foo) if mtlb_double(foo) is real
  lps = 1 ./(lps(mtlb_find(abs(mtlb_double(foo)))))';
  if ~isempty(lps) then
    A = mtlb_a(lps*mtlb_double(mtlb_e(a,ipp)),%pi*mtlb_logic(lps*mtlb_double(mtlb_e(a,ipp)),"==",1));
    if size(A,1)>1 then
      ipp = mtlb_e(ipp,mtlb_find(bool2s(~mtlb_sum(bool2s(bool2s(mtlb_logic(mtlb_s(A,fix(A)),"<",%eps*A))|bool2s(mtlb_logic(mtlb_s(1,mtlb_s(A,fix(A))),"<",%eps*A)))))));
    else
      ipp = mtlb_e(ipp,mtlb_find(bool2s(bool2s(~mtlb_logic(A-fix(A ./1) .*1,"<",%eps*A))|bool2s(mtlb_logic(mtlb_s(1,A-fix(A ./1) .*1),"<",%eps*A)))));
    end;
  end;
end;
I = mtlb_i(I,ipp,mtlb_a(mtlb_e(I,ipp),1));
endfunction
