function A=leibnitz(x,y)
// LEIBNITZ
//		A=LEIBNITZ(X,Y)
//		Leibnitz-Sector formula (closed curves area)
//
//		Examples:
//		1)	A=LEIBNITZ(Z)
//			 Z is a matrix with 2 rows. The 1st
//			 row equals x, the 2nd equals y.
//		2)	A=LEIBNITZ(CVEK)
//			 CVEK is a complex Vector, Real part
//			 equals x, imaginary part equals y.

// Number of arguments in function call
[%nargout,%nargin] = argn(0)

// Display mode
mode(0);

// Display warning for floating point exception
ieee(1);

if %nargin==1,
	[zx,sx]=size(x);
	if (zx==1 | sx==1) then
		if ~isreal(x)==1,
			y=imag(x);
			x=real(x);
		else
			disp('That will not work !');
			return;
		end
	else
		if zx==2,
			y=x(2,:);
			x=x(1,:);
		else
			disp('That will not work !');
			return;
		end
	end
end

x=x(:); y=y(:);
LX=length(x); LY=length(y);
A=abs(0.5 .*( (x.')*[diff(y);y(1)-y(LX)]  - (y.')*[diff(x);x(1)-x(LX)] ));

endfunction
