function y = mamufo(Q,xi,tnorm)
// MAMUFO        markov random function 1st order
//       
//           Y=MAMUFO(Q,XI,TNORM)          
// 
//Q       : probability matrix (transition prob.)    
//XI      : vector with possible values              
//TNORM   : time axis 

// Ouput variables initialisation (not found in input variables)
y=[];

// Display mode
mode(0);

// Display warning for floating point exception
ieee(1);

k0 = 1:size(mtlb_double(xi))*[0;1];
ones(35,1)*rand("seed");
// Gleichverteilung
%v0 = size(mtlb_double(Q));
U = ones(%v0(1),%v0(2));
%v0 = size(mtlb_double(xi));
I = ones(%v0(1),%v0(2))';
%v0 = size(mtlb_double(Q));
E = eye(%v0(1),%v0(2));
A = mtlb_t(Q);
pxi = (inv(mtlb_s(mtlb_a(mtlb_double(mtlb_t(Q)),U),E))*I)';
// Auftrittswahrscheinlichkeiten

n = size(mtlb_double(tnorm))*[0;1];
// Anzahl der Zeitpunkte 
y = zeros(1,n);
%v0 = size(mtlb_double(tnorm));
x = rand(%v0(1),%v0(2));
for k = 1:n
  sumpxi = cumsum(pxi,firstnonsingleton(pxi));
  a = mtlb_logic(x(1,k),"<",sumpxi);
  // BEDINGTE Wahrscheinlichkeiten
  suma = cumsum(bool2s(a),firstnonsingleton(bool2s(a)));
  // -> Wahrscheinlichkeitsmatrix
  w = mtlb_logic(suma,"==",1);
  y(1,k) = mtlb_double(xi)*w';
  index = k0*w';
  pxi = A(:,index);
  // Spalte Nr. (index)
  pxi = mtlb_t(pxi);
end;
endfunction
