function Smark=markomat(N,pself,struc)
// MARKOMAT
//		Smark=MARKOMAT(N,PSELF,[STRUC])
//
//		Creation of a Markov Transition Matrix of 1st order.
//		N is the size of the square matrix, pself is the
//		self probability of all states.
//		struc is a string. If it is 'updo', the transitions
//		from elements 1 to N or reverse are not enabled.

[%nargout,%nargin]=argn(0);
if %nargin==0 then
	N=5;
	pself=0.9;
	struc='updo';
end
if %nargin==1 then
	pself=0.9;
	struc='updo';
end
if %nargin==2 then
	struc='updo';
end

Smark=zeros(N,N);

pnext=(1 - pself)/2;

z=1:1:N;
s=1:1:N;
Smark=pself .*eye(N,N);

for z=2:1:N
	Smark(z,z-1)=pnext;
	Smark(z-1,z)=pnext;
end

if struc~='updo' then					// transition from element
	Smark(1,N)=pnext;					// 1 to N and reverse
	Smark(N,1)=pnext;					// is possible
else						
	Smark(1,2)=2*pnext;					// transition from element  
	Smark(N,N-1)=2*pnext;				// 1 to N and reverse
end										// is possible

endfunction