function [p,rxx]=markov(Q,merkmal,z)
// MARKOV	Autocorrelation of a stationary Markov process
//
//		[P,RXX]=MARKOV(Q,MERKMAL,Z)
// 
//		Q	: probability matrix
//		MERKMAL	: values of random process 
//		Z	: 'Time'-Difference for ACF 
//		P	: probability of states
//		RXX	: Rxx(z)

zabs=abs(z);
szab=size(z)*[0;1];
rxx=zeros(1,szab);
U=ones(Q);
E=eye(Q);
I=ones((size(Q)*[0;1]),1);
p=((Q.')+U-E)\I;
for L=1:szab;
	zmax=zabs(1,L);
	rxx(1,L)=merkmal*((Q.')^zmax)*(merkmal .*p.')';
end;

endfunction