function Qout=maskand(Qin,msk);
// MASKAND	evaluate equalness of masks
//
//		Qout=MASKAND(Qin,MSK)
//
//		MSK	: Matrix 3x3
//		Qin	: Input-matrix
//		Qout: Output-matrix

[z,s]=size(msk);
if ~(z==3 & s==3),
	return;
end

msk(2,2)=1;

[pz1,ps1]=find(msk==1);
pz1=2-pz1;		// shifting Y-direction
ps1=2-ps1;		// shifting X-direction

[pz0,ps0]=find(msk==0);
pz0=2-pz0;		// shifting Y-direction
ps0=2-ps0;		// shifting X-direction

Qout=Qin;
for k=1:1:length(pz1),
	Qout=bool2s(Qout & shiftmat(Qin,ps1(k),pz1(k)));
end
for k=1:1:length(pz0),
	Qout=bool2s(Qout & (~shiftmat(Qin,ps0(k),pz0(k))));
end

endfunction