function [Q,os]=ostern(j);
// OSTERN	calculation of the eastern day
//
//		[Q,os]=ostern(year)
//
//		year	:  scalar number representing the year.
//          Years may be within the range
//          1583 - 2299.
//
//		Q	:     Date of eastern sunday in the form
//          [day, month, year]
//
//		os	:    difference between 1st of January and
//          eastern sunday in days.


if j<1583 | j>2299 then,
	disp('Year is not in the allowed range 1583-2299');
	return;
end

anzfebr=dday([1,2,j;1,3,j]);

if j>=1583 & j<=1699 then, m=22; n=2; end
if j>=1700 & j<=1799 then, m=23; n=3; end
if j>=1800 & j<=1899 then, m=23; n=4; end
if j>=1900 & j<=2099 then, m=24; n=5; end
if j>=2100 & j<=2199 then, m=24; n=6; end
if j>=2200 & j<=2299 then, m=25; n=0; end

a=modulo(j,19);
b=modulo(j,4);
c=modulo(j,7);
d=modulo(19*a+m,30);
e=modulo(2*b+4*c+6*d+n,7);

t=22+d+e;

if t>31 then,			    // Eastern in April
	t=d+e-9;
	if t==26 then, t=19; end
	if (t==25 & d==28 & e==6 & a>10) then, t=18; end
    os=62+anzfebr+t;
else
	os=31+anzfebr+t;	// Eastern in March
end
os=os-1;
Q=calcdat([1,1,j],os);

endfunction
