function [y] = overlapp(x,N,ovl)
//OVERLAPP   Splitting of a vector in overlapping segments
// 
//Y=OVERLAPP(X,N,OVL)
// 
//A vector X is separated into several overlapping segments (overlapping OVL),
//so that segments of a length N+2*OVL are created. These segments are contained
//as rows in a matrix Y (one row represents a segment)

y=[];
[%nargout,%nargin] = argn(0)

// Display mode
mode(0);

// Display warning for floating point exception
ieee(1);

lx = max(size(mtlb_double(x)));                  // Lnge der Originalfunktion
if %nargin==1 then
  N = 2 .^mtlb_s(mtlb_double(nextpow2(lx)),2);   // Sequenzabschnitts-Grundlnge
  ovl = mtlb_double(N)/2;
end;
ntimes = floor(lx/mtlb_double(N));
// Anzahl der resultierenden Zeitpunkte 
xcut = mtlb_e(x,mtlb_imp(1,mtlb_double(N)*ntimes));
// Cropping der letzten Restwerte
xcut = matrix(mtlb_double(xcut),N,ntimes);
// Wandlung in Matrix
xupper = [xcut(mtlb_imp(1,mtlb_double(ovl)),mtlb_imp(2,ntimes)),zeros(real(mtlb_double(ovl)),1)];
xlower = [zeros(real(mtlb_double(ovl)),1),xcut(mtlb_imp(mtlb_a(mtlb_s(mtlb_double(N),mtlb_double(ovl)),1),mtlb_double(N)),mtlb_imp(1,mtlb_s(ntimes,1)))];
y = [xlower;xcut;xupper].';
endfunction
