function plotmea(a1,a2,idx);
// Plotting Measurement Data of MGCplus MEA files
//
// Example:
//     [a1,a2]=cp42mea();
//     plotmea(a1,a2);

[%nargout,%nargin] = argn(0)

// Display mode
mode(0);

// If only 2 arguments, everything is plotted
if %nargin==2,
  idx=1:1:size(a2,1);
end

fh=get("current_figure");
fh.figure_name=basename(a1.filename);
fh.figure_position=[0,0];
fh.figure_size=[800,900];
fh.visible="off";

numbchan=length(idx);

for p=1:1:numbchan,
  k=idx(p);
  subplot(numbchan,1,p);
  plot2d(a2(k).timeax,a2(k).data);
  xtitle(a2(k).ChannelName,"Time",a2(k).Unit);
end

fh.visible="on";

endfunction