function y=polyval(C,x);
//POLYVAL   polynomial evaluation
//
//C : Polynomial coefficients (vector)
//    C (length=N+1) builds a polynomial with the form
//
//    Y=C(1)*x^N + c(2)*x^(N-1) + ... + C(N)*x + C(N+1)
//
//x : Scalar, vector matrix with values, where the polynial should be evaluated
//y : Result of polynomial evaluation
//
//POLYVAL behaves like the matlab function polyval

LC=length(C);
C=C(LC:-1:1);
s=poly(C,'s',"coeff");
y=horner(s,x);

endfunction
