function [mp,r]=ponbowl(puks)
// PONBOWL                   
//		[MP,R]=PONBOWL(PUKS)             
// 
// 4 points define a the surface of a bowl. These points are
// given in a matrix:                           
//  		PUKS=[x1 y1 z1;x2 y2 z2;...;x4 y4 z4]
// MP is the center of the bowl, R its radius. 
// If the 4 points are laying on a circle, then the linar 
// equation system is not defined anymore.          

a1=puks(2,1:3)-puks(1,1:3);
a2=puks(3,1:3)-puks(1,1:3);
a3=puks(4,1:3)-puks(2,1:3);
a=[a1;a2;a3];
b1=(puks(2,1:3) .^2) - (puks(1,1:3) .^2);
b2=(puks(3,1:3) .^2) - (puks(1,1:3) .^2);
b3=(puks(4,1:3) .^2) - (puks(2,1:3) .^2);
b=0.5 .*[sum(b1);sum(b2);sum(b3)];
mp=a\b;
divek=puks(1,1:3)-mp';
divek2=divek .^2;
r=sqrt(sum(divek2));

endfunction