function [mp,r]=ponci(puks)
// PONCI
//		[MP,R]=PONCI(PUKS)
// 
//		Three points define a circle. These points are
//		contained in the matrix
//		PUKS	: [x1 y1; x2 y2; x3 y3]   
//		MP		: circle center
//		R		: Radius of the circle          

mp=[];
r=[];
mtx=[puks(1,1:2)-puks(2,1:2);puks(2,1:2)-puks(3,1:2)];
vek=[sum((puks(1,1:2) .^2 - puks(2,1:2) .^2));sum((puks(2,1:2) .^2 - puks(3,1:2) .^2))];
vek=0.5 .*vek;

if rank(mtx)<2,	// numerical rank of "MTX"
	return;		// If it is smaller than 2,
end;			// function is left.

mp=inv(mtx)*vek;
mp=mp';
difvek=puks(1,1:2)-mp;
r=sqrt(difvek*difvek');

endfunction;