function [p] = primes(n)
//PRIMES Generate list of prime numbers.
//   PRIMES(N) is a row vector of the prime numbers less than or 
//   equal to N.  A prime number is one that has no factors other
//   than 1 and itself.

// Ouput variables initialisation (not found in input variables)
p=[];

// Display mode
mode(0);

// Display warning for floating point exception
ieee(1);

if max(size(mtlb_double(n)))~=1 then
  error("N must be a scalar");
end;
if mtlb_logic(mtlb_double(n),"<",2) then
  p = zeros(1,0);
  return;
end;
p = mtlb_imp(1,2,mtlb_double(n));
q = max(size(p));
p = mtlb_i(p,1,2);
for k = mtlb_imp(3,2,sqrt(mtlb_double(n)))
  if p((k+1)/2) then
    p = mtlb_i(p,(k*k+1)/2:k:q,0);
  end;
end;
p = p(p>0);
endfunction
