function [Sumriss,csout]=randzone(S)
// RANDZONE
//		Sumriss=RANDZONE(S);
// or
//		[Sumriss,csout]=RANDZONE(S);
//
//		The contour lines of areas of a (Sparse) matrix
//		are calculated. The matrix Sumriss has points (1),
//		wheren an area edge of S occures.
//		When two output arguments are used, the 2nd
//		argument csout contains vector data of the edges.
//		With "showcs(csout)" the vector data can be displayed.

[%nargout,%nargin]=argn(0);

erowin1=[0,0,0;1,1,0;1,1,0];
erowin2=[1,1,0;1,1,0;0,0,0];
erowin3=[0,1,1;0,1,1;0,0,0];
erowin4=[0,0,0;0,1,1;0,1,1];

wero1=sperob(S,erowin1);
wero2=sperob(S,erowin2);
wero3=sperob(S,erowin3);
wero4=sperob(S,erowin4);

weroall=wero1 & wero2 & wero3 & wero4
Sumriss=bool2s((S|weroall) & (~ (S & weroall))); // XOR operation

if %nargout==2 | %nargout==0,
	mtdil=ones(5,5);
	SM=spdilb(S,mtdil);
	SM=randzone(SM);

	msk1=[0,0,0;1,1,0;0,1,0];
	for k=1:1:4,
		msk=rot90(msk1,k);
		SM=SM - sperob(SM,msk);
		SM=(SM>0);
	end

	[ps,pz]=find(SM);
	plist1=pz + %i .*ps;
	plist2=plist1(1);
	


									// Aufbau der Abarbeitungsanzeige
	perc=0; percold=0;
	winID=progressionbar('Done : '+int2str(perc)+'%');
	LP0=length(plist1);				// Ursprngliche Lnge der Punkteliste

	csout=[];
	count=1;
	while length(plist1)>=1,
		pakt=plist1(1);

		perc=round(100*(1 - (length(plist1)/LP0)));
		if perc>=percold+1,
			msgwin='Done : '+int2str(perc)+'%';
			progressionbar(winID,msgwin);
			percold=perc;
		end
		
		prest=plist1(2:length(plist1));
		d=abs(prest-pakt);

		kall=1:1:length(d);

		ki=find(d<1.5);
		if length(ki)>=1,
			ki=ki(1);
			pnext=prest(ki);
			prest=prest(kall~=ki);
			plist2=[plist2,pnext];

			plist1=[pnext,prest(:).'];
		else					// Kein Nachbar gefunden
			plist2=[plist2,plist2(1)];	// Schlieen des Zugs

			csakt=[count,real(plist2);length(plist2),imag(plist2)];
			csout=[csout,csakt];
			count=count+1;
			plist1=prest;
			if length(plist1)>1,
				plist2=plist1(1);
			end
		end
	end
	winclose(winID);
end