function xneu=shiftmat(x,dx,dy)
// SHIFTMAT
//		XNEU=SHIFTMAT(X,DX,DY)
//
//		Matrix shifting by DX columns to the right and
//		DY lines to the bottom.
//		Shift to the left / top by negative values
//		of DX and DY.

[zx,sx]=size(x);
						        // Verschiebung rechts/links
if dx>=0
	xneu=[zeros(zx,dx),x(:,1:sx-dx)];
else
	dx=-dx;
	xneu=[x(:,dx+1:sx),zeros(zx,dx)];
end
						        // Verschiebung nach unten/oben
if dy>=0
	xneu=[zeros(dy,sx);xneu(1:zx-dy,:)];
else
	dy=-dy;
	xneu=[xneu(dy+1:zx,:);zeros(dy,sx)];
end
endfunction