function [xc,yc]=showcs(xc,yc)
//SHOWCS   Utility to display contour data
//
//The SciLab function "[xc,yc]=contour2di(x,y,z,nz)" delivers the contours described
//by two row vectors. With this routine you can visualize the contour data and you can
//convert the data to a MatLab typical representation (Quite simple: cs=[xc;yc])
//
//Examples:
//
//1) cs=showcs(xc,yc);
//2) [xc,yc]=showcs(cs);


// Number of arguments in function call
[%nargout,%nargin] = argn(0)
mode(0);
ieee(1);

if %nargin==1,
  cs=xc;
  yc=cs(2,:);
  xc=cs(1,:);
end
if %nargin==2,
  cs=[xc(:),yc(:)].';
end

k=1;
n=yc(k);
c=2;
h=gcf();
h.visible='off';
while k+yc(k)<size(yc,2)
  n=yc(k);
  plot2d(xc(k+(1:n)),yc(k+(1:n)),c)
  k=k+n+1;
end
h.visible='on';

if %nargout==1,
  xc=cs;
end

endfunction
