function area=simpson(y,dx)
// SIMPSON
//		AREA=SIMPSON(Y,DX)
//
//		Fast Simpson Integration of equidistant defined functions. 
//		Each row of the matrix Y (vector is also possible) represents
//		a function. DX is the equidistant abscissa distance.
//		AREA is the result !
//
//		Example:
//				[X,P]=meshgrid(0:(%pi/100):(2*%pi),0:0.1:1);
//				Y=cos(P .*X) .^2;
//				area=simpson(Y,%pi/100)

[%nargout, %nargin]=argn(0);

if %nargin==1 then,
	dx=1;
end;

[zx,N]=size(y);

if modulo(N,2)==0
	y=y(:,2:1:$);
	N=N-1;	
end

k4=2:2:N-1;
k2=3:2:N-1;

y(:,k4)=4 .*y(:,k4);
y(:,k2)=2 .*y(:,k2);

area=sum(y,'c');
area=(1/3) .*area .*dx;

endfunction