function Qdil=spdilb(Q,mask);
// SPDILB	Binary Dilation of matrices
//
//		QDIL=SPDILB(Q,MASK);
//
//		Q		: matrix (binary info)
//		MASK	: Dilation window
//		QDIL	: output matrix
//
//		calling:
//		1)	QDIL=SPDILB(Q)
//			A Mask MASK=ONES(3,3) is used
//		2)	QDIL=SPDILB(Q,MASK)

[%nargout,%nargin]=argn(0);

Qdil=[];
if %nargin==0
	error('No Input Arguments are given !');
	return;
end
if %nargin==1
	mask=ones(3,3);
end
	
[zm,sm]=size(mask);

if ((modulo(zm,2)==0)|(modulo(sm,2)==0)) then,
	[zmask,smask]=find(mask);
	zmask=zmask - ceil((zm+1)/2);		// relative Positionen bezglich
	smask=smask - ceil((sm+1)/2);		// Maskenmitte
	NMASK=length(zmask);
else
	[zmask,smask]=find(mask);
	zmask=zmask - ceil(zm/2);		// relative Positionen bezglich
	smask=smask - ceil(sm/2);		// Maskenmitte
	NMASK=length(zmask);
end

Qdil=bool2s(shiftmat(Q,smask(1),zmask(1)) | shiftmat(Q,smask(2),zmask(2)));
if NMASK>2
	for k=3:1:NMASK
		Qdil=bool2s(Qdil | shiftmat(Q,smask(k),zmask(k)));
	end
end
endfunction	