function Qero=sperob(Q,mask);
// SPEROB
//		QERO=SPEROB(Q,MASK);
//
//		Binary Erosion of matrices
//		Q	: Input matrix containing 0 and 1
//		MASK	: Erosion windows
//		QERO	: output matrix
//
//		callings:
//		1)	QERO=SPEROB(Q)
//			a mask MASK=ONES(3,3) is used
//
//		2)	QERO=SPEROB(Q,MASK)

[%nargout,%nargin]=argn(0);

if %nargin==0
	error('No Input Arguments are given !');
	return;
end
if %nargin==1
	mask=ones(3,3);
end
	
[zm,sm]=size(mask);

if ((modulo(zm,2)==0)|(modulo(sm,2)==0)),
	[zmask,smask,vmask]=find(mask);
	zmask=zmask - ceil((zm+1)/2);		// relative Positionen bezglich
	smask=smask - ceil((sm+1)/2);		// Maskenmitte
	NMASK=length(zmask);
else
	[zmask,smask]=find(mask);
	zmask=zmask - ceil(zm/2);		// relative Positionen bezglich
	smask=smask - ceil(sm/2);		// Maskenmitte
	NMASK=length(zmask);
end

Qero=bool2s(shiftmat(Q,smask(1),zmask(1)) & shiftmat(Q,smask(2),zmask(2)));
if NMASK>2
	for k=3:1:NMASK
		Qero=bool2s(Qero & shiftmat(Q,smask(k),zmask(k)));
	end
end

endfunction