function [csout] = vecsort(csin,tol)
//VECSORT Defragment vector data
// 
//CSOUT=VECSORT(CSIN)
// 
//CSIN is a contour data matrix, which is delivered for example
//by the function
//	[xc,yc]=contour2di(...);
//	cs=[xc;yc]

// Ouput variables initialisation (not found in input variables)
csout=[];

// Number of arguments in function call
[%nargout,%nargin] = argn(0)

// Display mode
mode(0);

// Display warning for floating point exception
ieee(1);

if %nargin==1 then
  tol = 0.0001;
end;

A = csanaly2(csin,tol);
// Nachbarschaftsanalyse

SP1 = 13;
// Anfangsspalten der Nachbarindizes
SP2 = SP1+(size(mtlb_double(A),2)-13+1)/2;
SP3 = size(mtlb_double(A),2);
// letzte Spalte

kdone = zeros(size(mtlb_double(A),1),1);
%v0 = size(kdone);
kcount = zeros(%v0(1),%v0(2));
// Index von einfachen, direkten Vektoren
// Verzweigung an beiden Enden
// Linienende und Verzweigung
// keine Nachbarn (separate Vektoren)

ki = find(bool2s(bool2s(bool2s(bool2s(bool2s(mtlb_logic(mtlb_double(A(:,11)),">",1))&bool2s(mtlb_logic(mtlb_double(A(:,12)),">",1)))|bool2s(bool2s(mtlb_logic(mtlb_double(A(:,11)),"==",0))&bool2s(mtlb_logic(mtlb_double(A(:,12)),">",1))))|bool2s(bool2s(mtlb_logic(mtlb_double(A(:,11)),">",1))&bool2s(mtlb_logic(mtlb_double(A(:,12)),"==",0))))|bool2s(bool2s(mtlb_logic(mtlb_double(A(:,11)),"==",0))&bool2s(mtlb_logic(mtlb_double(A(:,12)),"==",0)))))';
ki = [ki;find(bool2s(mtlb_logic(abs(mtlb_double(A(:,9))-mtlb_double(A(:,10))),"<=",mtlb_double(tol))))'];
%v0 = size(ki);
kdone = mtlb_i(kdone,ki,3*ones(%v0(1),%v0(2)));
// Abarbeitungsvektor setzen

kstep = ki;
%v0 = size(kstep);
countvek = zeros(%v0(1),%v0(2));

kioffs = max(size(ki));
// Teilvektoren mit einem Nachbarn an
// einem Ende und Verzweigung am anderen
ki1 = find(bool2s(bool2s(bool2s(bool2s(mtlb_logic(mtlb_double(A(:,11)),"==",1))&bool2s(mtlb_logic(mtlb_double(A(:,12)),">",1)))|bool2s(bool2s(mtlb_logic(mtlb_double(A(:,11)),">",1))&bool2s(mtlb_logic(mtlb_double(A(:,12)),"==",1))))&bool2s(kdone==0)))';
// Teilvektoren: Linienende und nur
// ein Nachbar
ki2 = find(bool2s(bool2s(bool2s(bool2s(mtlb_logic(mtlb_double(A(:,11)),"==",0))&bool2s(mtlb_logic(mtlb_double(A(:,12)),"==",1)))|bool2s(bool2s(mtlb_logic(mtlb_double(A(:,11)),"==",1))&bool2s(mtlb_logic(mtlb_double(A(:,12)),"==",0))))&bool2s(kdone==0)))';
ki = [ki1;ki2];

KL = [];
%v0 = size(ki);
kdone = mtlb_i(kdone,ki,2*ones(%v0(1),%v0(2)));

counter = 1;
while max(size(ki))>1
  kakt = ki(1);
  // ! L.51: At lest one operand is an empty matrix for operator: KL==kakt, result set to []

  if ~isempty(mtlb_find([])) then
    ki = ki(2:max(size(ki)));
  else
    while ~isempty(kakt)
      // Nachbar-Bestimmung
      // ------------------
      if kdone(kakt)==0 then
        kdone = mtlb_i(kdone,kakt,1);
      end;
    
      KL = [KL;kakt];
      countvek = [countvek;counter];
      B = A(kakt,:);
    
      if bool2s(mtlb_logic(mtlb_double(mtlb_e(B,11)),"==",1))&bool2s(mtlb_logic(mtlb_double(mtlb_e(B,12)),"~=",1)) then // max. 1 Nachbar wird ausgelesen
       nbh = mtlb_e(B,SP1:SP2-1);
      end;
      if bool2s(mtlb_logic(mtlb_double(mtlb_e(B,11)),"~=",1))&bool2s(mtlb_logic(mtlb_double(mtlb_e(B,12)),"==",1)) then // max. 1 Nachbar wird geliefert
       nbh = mtlb_e(B,SP2:SP3);
      end;
      if bool2s(mtlb_logic(mtlb_double(mtlb_e(B,11)),"==",1))&bool2s(mtlb_logic(mtlb_double(mtlb_e(B,12)),"==",1)) then // zwei potentielle Nachbarn
       nbh = mtlb_e(B,SP1:SP3);
      end;
      // ! L.74: mtlb(nbh) can be replaced by nbh() or nbh whether nbh is an M-file or not
      // ! L.74: mtlb(nbh) can be replaced by nbh() or nbh whether nbh is an M-file or not
      // !! L.74: Unknown function nbh not converted, original calling sequence used
      nbh = nbh(mtlb_logic(mtlb_double(mtlb(nbh)),">",0));
    
      // Welche Nachbarn sind relevant ?
      // -------------------------------
      if max(size(mtlb_double(nbh)))==1 then // Linienenden oder Vektor mit
       if kdone(nbh)==0 then // Verzweigungsbeginn
        kakt = nbh;
       else
         if kdone(nbh)==2 then
           KL = [KL;nbh];
           countvek = [countvek;counter];
           kakt = [];
         else
           kakt = [];
         end;
       end;
      else
        if isempty(mtlb_find(bool2s(mtlb_logic(mtlb_double(KL),"==",mtlb_double(mtlb_e(nbh,1)))))) then
          nbh = mtlb_e(nbh,1);
        else
          nbh = mtlb_e(nbh,2);
        end;
        if kdone(nbh)==3 then
          kakt = [];
        else
          if kdone(nbh)==2 then
            KL = [KL;nbh];
            countvek = [countvek;counter];
            kakt = [];
          else
            kakt = nbh;
          end;
        end;
      end;
      // ------------------
    end;
    counter = counter+1;
    ki = ki(2:max(size(ki)));
  end;
end;

// Neuaufbau der Vektordaten
// -------------------------
kstep = [kstep;KL];
a1 = kstep;
a2 = countvek;
%v0 = a2;
mx = max(%v0,firstnonsingleton(%v0));
// Zusammenfassen einfacher, direkter
csout = [];
// Vektoren
p0 = mtlb_find(bool2s(mtlb_logic(a2,"==",0)));
for p = 1:1:max(size(p0))
  p0akt = p0(p);
  a1akt = mtlb_e(a1,p0akt);
  B = A(a1akt,:);
  csout = [csout,csin(:,mtlb_imp(mtlb_s(mtlb_double(mtlb_e(B,3)),1),mtlb_double(mtlb_e(B,4))))];
end;
for m = mtlb_imp(1,1,mx)
  // Zusammenfassen restlicher Vektoren
  flaggy = 0;
  p0 = mtlb_find(bool2s(mtlb_logic(a2,"==",m)));

  B = A(mtlb_e(a1,p0(1)),:);
  // Eventuelles Flipping des Startvektors
  if bool2s(mtlb_logic(mtlb_double(mtlb_e(B,11)),">",0))&bool2s(mtlb_logic(mtlb_double(mtlb_e(B,12)),"==",0)) then
    flaggy = 1;
  end;
  if bool2s(mtlb_logic(mtlb_double(mtlb_e(B,11)),"==",1))&bool2s(mtlb_logic(mtlb_double(mtlb_e(B,12)),">",1)) then
    flaggy = 1;
  end;

  if flaggy==1 then
    ctmp = [csin(:,mtlb_s(mtlb_double(mtlb_e(B,3)),1)),mtlb_fliplr(csin(:,mtlb_imp(mtlb_double(mtlb_e(B,3)),mtlb_double(mtlb_e(B,4)))))];
  else
    ctmp = csin(:,mtlb_imp(mtlb_s(mtlb_double(mtlb_e(B,3)),1),mtlb_double(mtlb_e(B,4))));
  end;
  // ! L.144: mtlb(ctmp) can be replaced by ctmp() or ctmp whether ctmp is an M-file or not
  // ! L.144: mtlb(ctmp) can be replaced by ctmp() or ctmp whether ctmp is an M-file or not
  // !! L.144: Unknown function ctmp not converted, original calling sequence used
  lp = ctmp(:,size(mtlb_double(mtlb(ctmp)),2));
  lp = mtlb_a(mtlb_double(mtlb_e(lp,1)),%i .*mtlb_double(mtlb_e(lp,2)));

  for p = 2:max(size(p0))
    B = A(mtlb_e(a1,p0(p)),:);
    p1 = csin(:,mtlb_e(B,3));  p2 = csin(:,mtlb_e(B,4));
    p1 = mtlb_a(mtlb_double(mtlb_e(p1,1)),%i .*mtlb_double(mtlb_e(p1,2)));
    p2 = mtlb_a(mtlb_double(mtlb_e(p2,1)),%i .*mtlb_double(mtlb_e(p2,2)));
    if mtlb_logic(abs(mtlb_s(mtlb_double(p1),mtlb_double(lp))),"<",abs(mtlb_s(mtlb_double(p2),mtlb_double(lp)))) then
      lp = p2;
      ctmp = [ctmp,csin(:,mtlb_imp(mtlb_double(mtlb_e(B,3)),mtlb_double(mtlb_e(B,4))))];
    else
      lp = p1;
      ctmp = [ctmp,mtlb_fliplr(csin(:,mtlb_imp(mtlb_double(mtlb_e(B,3)),mtlb_double(mtlb_e(B,4)))))];
    end;
  end;
  // ! L.159: mtlb(ctmp) can be replaced by ctmp() or ctmp whether ctmp is an M-file or not
  ctmp(2,1) = size(mtlb_double(mtlb(ctmp)),2)-1;
  csout = [csout,ctmp];
end;
endfunction
