function S=workdays(j,bdg,kath);
// WORKDAYS	create string table with information about working days
//
//		S=workdays(j,bdg,kath)
//
//		j	:	vector with year numbers
//		bdg	:	abbr. for german countries, default is
//				'hes' for Hessen
//		kath:	Boolean Variable (=1 for catholic areas)

[%nargout,%nargin]=argn();
if %nargin==1,
	bdg='hes';
	kath=0;
end
if %nargin==2,
	kath=0;
end
S=['Year';'Jan';'Feb';'Mar';'Apr';'Mai';'Jun';'Jul';'Aug';...
		'Sep';'Okt';'Nov';'Dez';'Sum'];

for p=1:1:length(j);
	W=j(p);
	for m=1:1:11,
		qs=[1,m,j(p)];
		qe=[1,m+1,j(p)];
		qe=calcdat(qe,-1);
		Q=[qs;qe];
		wt=werktage(Q,bdg,kath);
		W=[W;wt];
	end
	Q=[1,12,j(p);31,12,j(p)];
	wt=werktage(Q,bdg,kath);
	W=[W;wt];
	W=[W;sum(W(2:13))];
	Sakt=int2str(W);
	S=[S,Sakt];
end

[N,M]=size(S);
frmtstr='%s\t ';
for kx=2:1:M-1,
	frmtstr=frmtstr + '%s\t ';
end
frmtstr=frmtstr+'%s\n';
mprintf(frmtstr,S);
endfunction